// Ion sensing subroutines for MSP430 
// Copyright (C) 2002  Ville Vartiovaara
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Author: Ville Vartiovaara Ville.Vartiovaara@hut.fi


#include "msp430x14x.h"
#include "../main.h"
#include "process_data.h"
#include "../lib/datainit.h"

unsigned long int decr;

void extract(void)
{
   unsigned int i, limit, decr2;
   
   limit=12750/step + peak_x; 	// because (1<<8)*50=12750, and map length=50 =>
   				// limit=50/(step>>8) + peak_x
				
   for(i=peak_x; i<limit; i++)
     {
	decr=gauss_map[(step*(i-peak_x))>>8]; // flame term to be extracted
	decr=decr*peak_y;
	
	decr=decr>>8;
	
	
	if(data[i]<decr)
	  data[i]=0;
	else data[i]-=decr;

     }
   
}
