// Ion sensing subroutines for MSP430 
// Copyright (C) 2002  Ville Vartiovaara
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Author: Ville Vartiovaara Ville.Vartiovaara@hut.fi


#include "msp430x14x.h"
#include "../main.h"
#include "process_data.h"
#include "../lib/datainit.h"

void find_gauss(void)
{
   
   unsigned int i, y0, y0tmp, deg2, deg8, peak_y_tmp;
   y0=0;
   y0tmp=0;
   deg2=deg+deg;
   deg8=deg2+deg2;
   deg8+=deg8;
   
   if(peak_x<deg8)
     {
	step=0;
	return;
     }
   
   for(i=(peak_x-deg8); i<(peak_x-deg8)+deg2; i++)
     {
	y0+=data[i];
     }
   
   while(y0>deg2)
     {
	y0tmp+=1;
	y0-=deg2;
     }
   
   y0tmp++;
   
   if(y0tmp>2047)
     {	
	y0=y0tmp<<4;
	peak_y_tmp=peak_y>>4;
     }
   else if (y0tmp>1023)
     {
	y0=y0tmp<<5;
	peak_y_tmp=peak_y>>3;
     }
   else if (y0tmp>511)
     {
	y0=y0tmp<<6;
	peak_y_tmp=peak_y>>2;
     }
   else if (y0tmp>255)
     {	
	y0=y0tmp<<7;
	peak_y_tmp=peak_y>>1;
     }
   else 
     {
	y0=y0tmp>>8;
	peak_y_tmp=peak_y;
     }
   
   step=((1<<8)*(50-gauss_imap[(int)((y0tmp)/peak_y)]))/20;
}
