// Ion sensing subroutines for MSP430 
// Copyright (C) 2002  Ville Vartiovaara
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Author: Ville Vartiovaara Ville.Vartiovaara@hut.fi


#include "msp430x14x.h"
#include "../main.h"
#include "process_data.h"
#include "../lib/datainit.h"

void find_peak(void)
{
   unsigned int i, len4, max, sum;
   
   len4=len-4;	// len4=len-4
   i=peak_x;    // start from predef. offset
   peak_y=0;    // with no expectations...
   
   if(len-peak_x <= 3) return; // len-peak_x must be > 3 to make sense
   
   max=sum=data[i]+data[i+1]+data[i+2];
   
   while((++i)<(len-4))
     {
	if(sum>=max)
	  { 
	     max=sum;
	     peak_x=i+1;
	  }
	sum +=data[i+3];
	sum -= data[i];
     }
   
   peak_y = (data[peak_x-1]+data[peak_x]+data[peak_x+1])/3;	
}

   
   
