// Ion sensing subroutines for MSP430 
// Copyright (C) 2002  Ville Vartiovaara
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Author: Ville Vartiovaara Ville.Vartiovaara@hut.fi


#include "msp430x14x.h"
#include "../main.h"
#include "process_data.h"
#include "../lib/datainit.h"

//
// Coordinates the PPP extraction.
// reads data[] and puts the result into peak_deg, if it's reasoble.
// if not, peak_deg=0 and step=0;
// 
//
//



void process_data(void)
{
   unsigned int deg = (tdc_end-tdc_start)/20; // amount of data points per degree
   if(deg<1) deg=1;	// to be sane
   P1OUT|=0x04;		// turn led on
   
   peak_x=0;		// start from the beginning of the data
   find_peak(); 	// find the highest point
   fpeak_x=peak_x; 	// for debugging
   find_gauss(); 	// fit the gauss curve
   extract();		// extract it from the data
   peak_x+=deg;		// move a bit forward
   peak_x+=deg;		// -"-
   find_peak();		// find the highest point in the remainders (->PPP)
   
   if(step!=0)		// if the curve could be fitted
     {
	peak_deg=(20*(peak_x-tdc_start))/(tdc_end-tdc_start);
     }
   else peak_deg=0;	// if not, no result
   P1OUT&=~(0x04); 	// turn led off
}
