// Ion sensing subroutines for MSP430 
// Copyright (C) 2002  Ville Vartiovaara
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Author: Ville Vartiovaara Ville.Vartiovaara@hut.fi


#include "msp430x14x.h"
#include "../main.h"
#include "../routines/process_data.h"
#include "../lib/datainit.h"

void getsample(void)
{
   unsigned int sample;
   unsigned int tdclen, ccr_new; 
   pos=0; //pointer in data[], i.e. sample from the beginning of this window
   len=512; // to be reduced when we get to know the speed
   tdc_start=0; //when tdc gets active, tdc_start=pos;
   tdc_end=0; //-"-
   tdc_started=tdc_ended=0;
      
   
   
   TACTL |= MC0;	// start timer_a in upmode (count up to CCR0)
   while(pos<len)
     {
	while(!result);     // wait for conversion to finish
	sample=result; result=0; // for the loop above...
	if(sample<50) sample=0;   // offset compensation
	else sample=sample-50;
       	data[pos]=sample; // save the sample
     }
   
   
   TACTL&=~MC0;		// stop timer_a
   
   tdclen=tdc_end-tdc_start; //
   CCR0=CCR0/20;	     //
   CCR0=CCR0*tdclen;	     //          
   if(CCR0<220)              //
     CCR0=220; // for 6000RPM //
   else if(CCR0>4500)        //
     CCR0=4500; // for 300RPM // CCR0=CCR0*(tdclen/20)
   
   delay=12000/CCR0; // (8000 cycles @ 1ms, spark lasts approx. 2ms)
   if(delay<1) delay=1;
   if(delay>36) delay=36;
  
 }

